package lv.lu.owljgraph;

import org.jgraph.JGraph;
import org.jgraph.graph.DefaultGraphModel;
import org.jgraph.graph.GraphLayoutCache;
import org.jgraph.graph.GraphModel;
import org.jgraph.plaf.basic.BasicGraphUI;

import com.jgraph.layout.JGraphFacade;
import com.jgraph.layout.organic.JGraphFastOrganicLayout;

public class OWLGraph extends JGraph {

    private static final long serialVersionUID = 4001168760444641481L;
    
    public OWLGraph() {
        this(new DefaultGraphModel());
    }
    
    public OWLGraph(GraphModel model) {
        super(model, new GraphLayoutCache(model, new OWLCellViewFactory(), true));
        
        setEditable(false);
        setConnectable(false);
        setDisconnectable(false);
        setAntiAliased(true);
        setGridSize(5);
        setGridEnabled(true);
        setDoubleBuffered(false);
        
        BasicGraphUI.MAXHANDLES = 2;
    }
    
    public void layoutGraph() {
        JGraphFacade facade = new JGraphFacade(this);
        facade.setIgnoresUnconnectedCells(false);
        JGraphFastOrganicLayout layout = new JGraphFastOrganicLayout();
        layout.run(facade);
        getGraphLayoutCache().edit(facade.createNestedMap(true, true));
    }
    
}