package lv.lu.owljgraph.vertex;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Insets;

import javax.swing.border.AbstractBorder;

import lv.lu.owljgraph.OWLGraphConstants;

import org.jgraph.graph.VertexRenderer;

public class OWLNoteRenderer extends VertexRenderer {
    
    private static final long serialVersionUID = 7756937188578423965L;

    private static final Insets insets = new Insets(15, 15, 15, 15);

    public OWLNoteRenderer() {
        super();
    }

    public void paint(Graphics g) {
        super.paint(g);
        final Graphics2D g2d = (Graphics2D) g;
        
        Dimension d = getSize();
        int w = d.width - 1;
        int r = 10;

        if (selected || hasFocus) {
            g2d.setStroke(OWLGraphConstants.SELECTION_STROKE);
        }
        
        g2d.setColor(getBackground());
        g2d.fillRect(w - r, -1, r + 1, r + 1);

        g2d.setColor(bordercolor);
        g2d.drawLine(w - r, 0, w, r);
        g2d.drawLine(w - r, 0, w - r, r);
        g2d.drawLine(w - r, r, w, r);

        g2d.setColor(getForeground());
    }

    @Override
    public Insets getInsets() {
        return insets;
    }
    
    @Override
    public Insets getInsets(Insets insets) {
        if (getBorder() != null) {
            Insets borderInsets;
            if (getBorder() instanceof AbstractBorder) {
                borderInsets = ((AbstractBorder)getBorder()).getBorderInsets(this, insets);
            } else {
                borderInsets = getBorder().getBorderInsets(this);
            }
            borderInsets.top += getInsets().top;
            borderInsets.right += getInsets().right;
            borderInsets.bottom += getInsets().bottom;
            borderInsets.left += getInsets().left;
            return borderInsets;
        } else {
            return insets;
        }
    }
    
}