package lv.lu.owljgraph.vertex;

import java.awt.Color;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;

import lv.lu.owljgraph.OWLGraphConstants;

import org.jgraph.graph.AttributeMap;
import org.jgraph.graph.EdgeView;
import org.jgraph.graph.VertexView;

public class OWLVertexView extends VertexView {

    private static final long serialVersionUID = -7580104499877930043L;

    public OWLVertexView(Object v) {
        super(v);
        
        OWLVertexCell vertex = (OWLVertexCell) v;
        setAttributes(vertex.getAttributes());

        AttributeMap map = getAttributes();

        Color background = OWLGraphConstants.getBackground(map);
        if (background == null) {
            OWLGraphConstants.setBackground(map, Color.WHITE);
        }

        Color borderColor = OWLGraphConstants.getBorderColor(map);
        if (borderColor == null) {
            OWLGraphConstants.setBorderColor(map, Color.BLACK);
        }
        
        Boolean opaque = (Boolean) map.get(OWLGraphConstants.OPAQUE);
        if (opaque == null) {
            OWLGraphConstants.setOpaque(map, true);
        }

    }

    /**
     * Code was copied from org.jgraph.graph.VertexRenderer.getPerimeterPoint() method
     */
    public Point2D getPerimeterPoint(EdgeView edge, Point2D source, Point2D p) {
        Rectangle2D bounds = getBounds();
        double x = bounds.getX();
        double y = bounds.getY();
        double width = bounds.getWidth();
        double height = bounds.getHeight();
        double xCenter = x + width / 2;
        double yCenter = y + height / 2;
        double dx = p.getX() - xCenter; // Compute Angle
        double dy = p.getY() - yCenter;
        double alpha = Math.atan2(dy, dx);
        double xout = 0, yout = 0;
        double pi = Math.PI;
        double pi2 = Math.PI / 2.0;
        double beta = pi2 - alpha;
        double t = Math.atan2(height, width);
        if (alpha < -pi + t || alpha > pi - t) { // Left edge
            xout = x;
            yout = yCenter - width * Math.tan(alpha) / 2;
        } else if (alpha < -t) { // Top Edge
            yout = y;
            xout = xCenter - height * Math.tan(beta) / 2;
        } else if (alpha < t) { // Right Edge
            xout = x + width;
            yout = yCenter + width * Math.tan(alpha) / 2;
        } else { // Bottom Edge
            yout = y + height;
            xout = xCenter + height * Math.tan(beta) / 2;
        }
        return new Point2D.Double(xout, yout);
    }

}