package lv.lu.protege.owl2uml.helper;

import java.util.HashSet;
import java.util.Set;

import lv.lu.owljgraph.vertex.OWLClassCell;
import lv.lu.protege.owl2uml.util.OWLVertexUtils;

import org.semanticweb.owl.model.OWLClass;
import org.semanticweb.owl.model.OWLDataProperty;
import org.semanticweb.owl.model.OWLDataRange;
import org.semanticweb.owl.model.OWLDescription;

public class OWLDataPropertyHelper extends OWLHelper {
    
    public static void addOWLDataProperties() {
        for (OWLDataProperty dataProperty: getActiveOntology().getReferencedDataProperties()) {
            addDataProperty(dataProperty);
        }
    }

    private static void addDataProperty(OWLDataProperty dataProperty) {
        Set<OWLDescription> domains = dataProperty.getDomains(getActiveOntology());
        Set<String> ranges = new HashSet<String>();
        
        for (OWLDataRange range: dataProperty.getRanges(getActiveOntology())) {
            ranges.add(parent.getOWLModelManager().getRendering(range));
        }
        
        for (OWLDescription domain: domains) {
            if (domain instanceof OWLClass) {
                Integer classHash = OWLVertexUtils.getHashCode((OWLClass) domain);
                OWLClassCell classCell = (OWLClassCell) vertices.shown.get(classHash);
                classCell.addProperty(dataProperty.toString(), ranges);
            }
        }
    }
    
}
