package lv.lu.protege.owl2uml.helper;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import lv.lu.owljgraph.OWLGraph;
import lv.lu.owljgraph.edge.OWLEdge;
import lv.lu.owljgraph.vertex.OWLVertexCell;
import lv.lu.protege.owl2uml.OWL2UML;

import org.semanticweb.owl.model.OWLOntology;

public abstract class OWLHelper {
    
    protected static class GraphObjects<T> {
        public Map<Integer, T> shown = new HashMap<Integer, T>();
        public Set<T> inserted = new HashSet<T>();
        public Set<T> removed = new HashSet<T>();
        public Set<T> updated = new HashSet<T>();
    }
    
    protected static OWL2UML parent = null;
    protected static GraphObjects<OWLVertexCell> vertices = null;
    protected static GraphObjects<OWLEdge> edges = null;

    public static void init(OWL2UML parent) {
        OWLHelper.parent = parent;
        vertices = new GraphObjects<OWLVertexCell>();
        edges = new GraphObjects<OWLEdge>();
    }
    
    public static void dispose() {
        vertices = null;
        edges = null;
    }
    
    protected static OWLGraph getGraph() {
        return parent.getGraph();
    }

    protected static OWLOntology getActiveOntology() {
        return parent.getOWLModelManager().getActiveOntology();
    }

}
