package lv.lu.protege.owl2uml.helper;

import java.util.HashSet;
import java.util.Set;

import lv.lu.owljgraph.vertex.OWLNoteCell;
import lv.lu.protege.owl2uml.util.OWLVertexUtils;

import org.jgraph.graph.DefaultGraphCell;

public class OWLNoteHelper extends OWLHelper {
    
    private static Set<OWLNoteCell> shownNotes = new HashSet<OWLNoteCell>();
    
    public static void init() {
        shownNotes.clear();
    }
    
    public static OWLNoteCell addOWLNote(String label, DefaultGraphCell connectedCell) {
        Set<DefaultGraphCell> connectedCells = new HashSet<DefaultGraphCell>();
        connectedCells.add(connectedCell);
        return addOWLNote(label, connectedCells);
    }
    
    public static OWLNoteCell addOWLNote(String label, Set<DefaultGraphCell> connectedCells) {
        OWLNoteCell noteCell = OWLVertexUtils.createOWLNote(label);
        Integer noteHash = OWLVertexUtils.getHashCode(noteCell, connectedCells);
        String noteId = noteCell.toString();
        noteCell = null;
        
        if (vertices.shown.containsKey(noteHash)) {
            noteCell = (OWLNoteCell) vertices.shown.get(noteHash);
        } else {
            noteCell = OWLVertexUtils.createOWLNote(noteId);
            vertices.shown.put(noteHash, noteCell);
            vertices.inserted.add(noteCell);
        }
        
        shownNotes.add(noteCell);
        vertices.updated.add(noteCell);
        return noteCell;
    }

    public static Set<OWLNoteCell> getShownNotes() {
        return shownNotes;
    }
    
}