package lv.lu.protege.owl2uml.ui.button;

import java.awt.event.ActionEvent;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.ObjectInputStream;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import lv.lu.owljgraph.OWLGraph;
import lv.lu.protege.owl2uml.OWL2UML;
import lv.lu.protege.owl2uml.bean.GraphLayout;
import lv.lu.protege.owl2uml.helper.OWLCommonHelper;

import org.jgraph.graph.GraphLayoutCache;

public class DeserializeButton extends OWLButton {

    private static final long serialVersionUID = -3179121248160881697L;

    public DeserializeButton(OWL2UML parent) {
        super("Load layout", "deserialize", parent);
    }

    public void actionPerformed(ActionEvent event) {
        if ("deserialize".equals(event.getActionCommand())) {
            File in = getDeserializeFile();
            if (in != null) {
                OWLGraph graph = parent.getGraph();
                try { 
                    ObjectInputStream inStream = new ObjectInputStream(
                            new BufferedInputStream(new FileInputStream(in)));
                    GraphLayoutCache graphLayoutCache = loadGraphLayout((GraphLayout) inStream.readObject());
                    inStream.close();
                    graph.setGraphLayoutCache(graphLayoutCache);
                    OWLCommonHelper.updateShownGraphObjects();
                    restoreCheckboxStates();
                } catch (Exception e) {
                    e.printStackTrace();
                    JOptionPane.showMessageDialog(parent, "Error occured while trying to load graph layout", "Error", JOptionPane.ERROR_MESSAGE);
                }
            }
        }
    }

    public File getDeserializeFile() {
        final JFileChooser fc = new JFileChooser();
        if (fc.showOpenDialog(parent) == JFileChooser.APPROVE_OPTION) {
            return fc.getSelectedFile();
        }
        return null;
    }
    
    protected GraphLayoutCache loadGraphLayout(GraphLayout layout) {
        isObjectPropertiesCheckboxSelected = layout.getIsObjectPropertiesCheckboxSelected();
        isCommentsCheckboxSelected = layout.getIsCommentsCheckboxSelected();
        isGeneralizationsCheckboxSelected = layout.getIsGeneralizationsCheckboxSelected();
        isAssociationsCheckboxSelected = layout.getIsAssociationsCheckboxSelected();
        return layout.getLayoutCache();
    }

}