package lv.lu.protege.owl2uml.ui.button;

import java.awt.event.ActionEvent;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import lv.lu.protege.owl2uml.OWL2UML;

public class ExportButton extends OWLButton {
    
    private static final long serialVersionUID = -5607531268707231664L;
    
    public ExportButton(OWL2UML parent) {
        super("Save as PNG", "export", parent);
    }
    
    public void actionPerformed(ActionEvent event) {
        if ("export".equals(event.getActionCommand())) {
            File out = getExportFile();
            if (out != null) {
                try {
                    BufferedImage img = parent.getGraph().getImage(null, 0);
                    ImageIO.write(img, "png", out);
                } catch (OutOfMemoryError e) {
                    e.printStackTrace();
                    JOptionPane.showMessageDialog(parent, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }
    
    public File getExportFile() {
        final JFileChooser fc = new JFileChooser();
        if (fc.showSaveDialog(parent) == JFileChooser.APPROVE_OPTION) {
            return fc.getSelectedFile();
        }
        return null;
    }

}