package lv.lu.protege.owl2uml.ui.button;

import java.awt.event.ActionListener;

import javax.swing.JButton;

import lv.lu.protege.owl2uml.OWL2UML;

public abstract class OWLButton extends JButton implements ActionListener {

    protected static final long serialVersionUID = 86308876454322019L;

    protected OWL2UML parent;

    // Checkbox states
    protected Boolean isObjectPropertiesCheckboxSelected;
    protected Boolean isCommentsCheckboxSelected;
    protected Boolean isGeneralizationsCheckboxSelected;
    protected Boolean isAssociationsCheckboxSelected;
    
    public OWLButton(String text, String actionCommand, OWL2UML parent) {
        super(text);
        this.parent = parent;
        setActionCommand(actionCommand);
        addActionListener(this);
    }

    protected void saveCheckboxStates() {
        isObjectPropertiesCheckboxSelected = parent.getObjectPropertiesCheckbox().isSelected();
        isCommentsCheckboxSelected = parent.getCommentsCheckbox().isSelected();
        isGeneralizationsCheckboxSelected = parent.getGeneralizationsCheckbox().isSelected();
        isAssociationsCheckboxSelected = parent.getAssociationsCheckbox().isSelected();
    }
    
    protected void selectAllCheckboxes() {
        parent.getObjectPropertiesCheckbox().setSelectProgrammatically(true);
        parent.getCommentsCheckbox().setSelectProgrammatically(true);
        parent.getGeneralizationsCheckbox().setSelectProgrammatically(true);
        parent.getAssociationsCheckbox().setSelectProgrammatically(true);
    }
    
    protected void restoreCheckboxStates() {
        parent.getObjectPropertiesCheckbox().setSelectProgrammatically(isObjectPropertiesCheckboxSelected);
        parent.getCommentsCheckbox().setSelectProgrammatically(isCommentsCheckboxSelected);
        parent.getGeneralizationsCheckbox().setSelectProgrammatically(isGeneralizationsCheckboxSelected);
        parent.getAssociationsCheckbox().setSelectProgrammatically(isAssociationsCheckboxSelected);
    }
    
}
