package lv.lu.protege.owl2uml.ui.checkbox;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JCheckBox;

import lv.lu.protege.owl2uml.OWL2UML;

public abstract class OWLCheckBox extends JCheckBox implements ItemListener {

    private static final long serialVersionUID = 7150672730793465832L;

    protected OWL2UML parent;
    
    public OWLCheckBox(String text, OWL2UML parent) {
        super(text);
        this.parent = parent;
        setSelected(true);
        addItemListener(this);
    }
    
    public void itemStateChanged(ItemEvent e) {
        Boolean visible = false;
        if (e.getStateChange() == ItemEvent.SELECTED) {
            visible = true;
        }
        doAction(visible);
        doAdditionalAction(visible);
    }
    
    public void setSelectProgrammatically(Boolean selected) {
        setSelected(selected);
        doAction(selected);
    }
    
    public void doAction() {
        doAction(isSelected());
    }
    
    protected void doAction(Object[] cells, Boolean visible) {
        parent.getGraph().getGraphLayoutCache().setVisible(cells, visible);
    }
    
    protected abstract void doAction(Boolean visible);
    
    protected abstract void doAdditionalAction(Boolean visible);
    
}
